=== debian/changelog ===
kalign (1:3.5.1-1) unstable; urgency=medium

  * New upstream version, Closes: #1127766.
    Relicensed to Apache 2.0
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Set upstream metadata fields: Documentation.

 -- Charles Plessy <plessy@debian.org>  Fri, 27 Feb 2026 17:00:20 +0900
